macroScript randomizer category:"UNC tools" buttontext:"UNConv" tooltip:"UNConv"
(
	global QArqPathCorrector
	fn tokenString str token =
	(
		idx = 0;start = 1;end = 0;strings = #()
		while (idx != undefined) do
		(
			idx = findString str token
			if idx == undefined then
			(	
				append strings str;continue
			)
			end = idx-1;newStr = subString str start end
			if newStr.count > 0 then
				append strings newStr
			str = replace str start (end+token.count) ""
		)
		strings
	)
	
	fn replaceString str replaceStr withStr =
	(
		theStr = " " + str;splitNames = tokenString  theStr replaceStr
		newStr = str
		if (splitNames.count >= 1) then
		(
			newStr = ""
			for s = 1 to splitNames.count do
			(
				newStr += splitNames[s]
				if s != splitNames.count then newStr += withStr
			)
			newStr = replace newStr 1 1 ""
		)	
		newStr
	)
	
	struct QArqPathCorrector
	(
		fn correct old_path =
		(
			-- Old paths
			a1 = #("x:\\","y:\\")
			-- New path parts for dfs system
			a2 = #("\\Projects\\","\\Libraries\\")
			-- dfs root
			r1 = "\\\\ARKVIZ-SERVER\\"
			new_path = old_path
			/* e.g:
				before (o:\stone\rock1.jpg)
				after (\\intranet.4arq.net\storage\arquitectura\rock1.jpg)
			*/
			if (findstring new_path "\\\\intranet.4arq.net\\") != undefined then return new_path
			for f=1 to a1.count do
			(
				new_path = replaceString old_path a1[f] (r1+a2[f])
				if new_path != old_path then exit
			)
			new_path
		),
		fn process =
		(
			format "Intranet Path Corrector v 0.1\n"
			format "2007  Daniel Santana\n\n"
			bitm = getclassinstances bitmaptex
			format "Found % \tBitmaps\n" (bitm.count)
			proxies = getclassinstances vrayproxy
			format "Found % \tVrayProxies\n" (proxies.count)
			ies_lights = getclassinstances Free_Area
			join ies_lights (getclassinstances Free_Linear)
			join ies_lights (getclassinstances Free_Point)
			join ies_lights (getclassinstances Target_Area)
			join ies_lights (getclassinstances Target_Linear)
			join ies_lights (getclassinstances Target_Point)
			format "Found % \tIES lights\n" (ies_lights.count)
			arr1 = #()
			join arr1 bitm
			join arr1 proxies
			join arr1 ies_lights
			format "Processing paths...\n"
			c = 0
			for i in arr1 do
			(
				if superclassof i != Light then
					old_path = (dotnetobject "System.String" (i.filename)).tolower()
				else
					old_path = (dotnetobject "System.String" (i.webfile)).tolower()
				
				if old_path != "" then
				(
					new_path = QArqPathCorrector.correct old_path
					if old_path != new_path then
					(
						if superclassof i != Light then
							i.filename = new_path
						else
							i.webfile = new_path
						format "(%) new filename = %\n" (classof i) (new_path)
						c+=1
					)
				)
			)
			format "% of % required path changes.\n" c (arr1.count)
			format "All done...\n"
		)
	)
	
	PathCorrector = QArqPathCorrector()
	PathCorrector.process()
) 